/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * unity-webapps-indicator-view.h
 * Copyright (C) Canonical LTD 2011
 * 
 * Author: Robert Carr <racarr@canonical.com>
 * 
unity-webapps is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * unity-webapps is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.";
 */


#ifndef __UNITY_WEBAPPS_INDICATOR_VIEW_LIBINDICATE_H
#define __UNITY_WEBAPPS_INDICATOR_VIEW_LIBINDICATE_H

#include "unity-webapps-indicator-view.h"
#include <libdbusmenu-glib/server.h>


#define UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE              (unity_webapps_indicator_view_libindicate_get_type())
#define UNITY_WEBAPPS_INDICATOR_VIEW_LIBINDICATE(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE, UnityWebappsIndicatorViewLibindicate))
#define UNITY_WEBAPPS_INDICATOR_VIEW_LIBINDICATE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE, UnityWebappsIndicatorViewLibindicateClass))
#define UNITY_WEBAPPS_IS_INDICATOR_VIEW_LIBINDICATE(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE))
#define UNITY_WEBAPPS_IS_INDICATOR_VIEW_LIBINDICATE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE))
#define UNITY_WEBAPPS_INDICATOR_VIEW_LIBINDICATE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), UNITY_WEBAPPS_TYPE_INDICATOR_VIEW_LIBINDICATE, UnityWebappsIndicatorViewLibindicateClass))

typedef struct _UnityWebappsIndicatorViewLibindicatePrivate UnityWebappsIndicatorViewLibindicatePrivate;

typedef struct _UnityWebappsIndicatorViewLibindicate UnityWebappsIndicatorViewLibindicate;


struct _UnityWebappsIndicatorViewLibindicate {
	UnityWebappsIndicatorView object;
	
	UnityWebappsIndicatorViewLibindicatePrivate *priv;
};

typedef struct _UnityWebappsIndicatorViewLibindicateClass UnityWebappsIndicatorViewLibindicateClass;

struct _UnityWebappsIndicatorViewLibindicateClass
{
	UnityWebappsIndicatorViewClass parent_class;
};

GType unity_webapps_indicator_view_libindicate_get_type (void) G_GNUC_CONST;

UnityWebappsIndicatorView *unity_webapps_indicator_view_libindicate_new (UnityWebappsIndicatorModel *model, const gchar *desktop_file);

void unity_webapps_indicator_view_libindicate_set_menu_server (UnityWebappsIndicatorViewLibindicate *view,
															   DbusmenuServer *menu_server);

#endif
