/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <glib.h>

#include "unity-webapps-scripts.h"

const gchar * TEST_REPO_FOLDER = "scripts";

static gchar *
get_repo_fullpath (void)
{
    return g_build_path (G_DIR_SEPARATOR_S, g_get_current_dir (), TEST_REPO_FOLDER, NULL);
}

gint
main (gint argc, gchar **argv)
{
#if defined (WITH_MEMORY_PROFILE)
    g_mem_set_vtable (glib_mem_profiler_table);
#endif

    gchar * defined_repo_path = get_repo_fullpath ();

    g_setenv ("UNITY_WEBAPPS_SCRIPT_REPO_PATH", defined_repo_path, TRUE);

    GList *list = unity_webapps_script_get_scripts_for_uri ("http://news.google.com/avxcc/sdsadsa");

    g_assert_cmpint (g_list_length (list), >=, 1);

    g_list_free_full (list, g_free);

    g_unsetenv ("UNITY_WEBAPPS_SCRIPT_REPO_PATH");
    g_free (defined_repo_path);

#if defined (WITH_MEMORY_PROFILE)
    g_mem_profile();
#endif

    return 0;
}
